﻿<% /*www.interestprograms.ru*/ %>

<% /* Вебстраница с блоками внедренного кода на движке ASPX */ %>

<% // самая первая строка, сведения для компилятора на каком языке программный код %>
<%@ Page Language="C#" %> 


<script runat="server">
    // Блок объявления типов, функций, переменных.
    // Написанный здесь код доступен на всей странице.
    // Исполняется на стороне сервера.

    // Создаем переменную для заголовка и названия страницы
    string namepage = "Динамическое создание таблицы. Движок ASPX";

    // Задаем количество столбцов по умолчанию
    int numberColumns = 4;
    int numberRows = 4;

    // Объявляем тип
    class CreateLinks
    {
        public string GetLinks()
        {
            Random r = new Random();
            string result = null;

            
            string rows = r.Next(1, 100).ToString();
            string columns = r.Next(1, 20).ToString();

            result += "<p>";
            result += "<strong>Создать таблицу &raquo;</strong> ";
            result += "<a href=\"table.aspx?rows=";
            result += rows;
            result += "&cols=";
            result += columns;
            result += "\">строк " + rows + ", столбцов " + columns + "</a><br />";
            result += "</p>";

            return result;
        }
    }

    CreateLinks createLinks = new CreateLinks();


</script>

<%
    // Блок на случай некорректных данных, 
    // такое всегда необходимо предусматривать.
    try
    {
        // Если здесь случится предвиденная или непредвиденная ошибка
        // блок try защитит пользователя от неприятной официальной страницы.

        // Преобразуем данные о столбцах в целое число.
        if (Request.Params["cols"] != null)
        {
            // Теперь мы точно знаем сколько столбцов запрошено
            numberColumns = int.Parse(Request.Params["cols"]);
        }

        // Преобразуем данные о строках в целое число.
        if (Request.Params["rows"] != null)
        {
            // Теперь мы точно знаем сколько строк запрошено
            numberRows = int.Parse(Request.Params["rows"]);
        }
    }
    catch
    {
        // В случае ошибки конвертирования типов выведем сообщение
        Response.Write("<span style='color:#f00;'>Не корретные данные строки запроса...</span>");
    }

%>


<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
<meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
    <title>
    <%
        Response.Write(namepage); 
        // Далее  конструкцию Response.Write("") будем заменять
        // альтернативным коротким кодом =выражение
    %>
    </title>
    <link rel="stylesheet" type="text/css" href="css/style.css" />
</head>
<body>
    
    <% 
       //  короткая конструкция не допускает внутри блока какого-либо другого кода
    %>
    <h1><% =namepage %></h1> 

    <p><a href="/table.cshtml">Веб страница на движке Razor</a><br />
    <a href="/">В начало</a></p>

    <% =createLinks.GetLinks() %>

    <p>
        Количество стобцов - <% =numberColumns %><br />
        Количество строк - <% =numberRows  %>
    </p>

  
    <%  // В блоках внедренного кода ASPX недопускается html разметка,
        // только в качестве строк.%>

    <table>
        <tr>
        <%for (int i = 0; i < numberColumns; i++)
        {
            Response.Write( "<th>Заголовок № " + (i + 1) + "</th>");
        }%>
        </tr>
        <%for (int row = 0; row < numberRows; row++){%>
        <tr>
            <%for (int col = 0; col < numberColumns; col++){%>
             <td><% =((row + 1) + "x" + (col + 1)) %></td>
            <%}%>
        </tr>
        <%}%>
    </table>

</body>
</html>
